#include "BuildLibrary.h"

#include "Logger.h"
#include "Directory.h"

BuildLibrary::BuildLibrary(const FileSystemPath& build_config)
    : m_build_config(build_config)
{
}

Status BuildLibrary::scan()
{
    LOG_INFO("Scanning build file at: " << m_build_config);
    const auto search_dir = m_build_config.parent_path();
    const auto status = Directory::getFilesWithExtension(search_dir, 
        ".cpp", 
        m_sources, 
        true);
    return status;
}

const Vector<FileSystemPath>& BuildLibrary::get_sources() const 
{
    return m_sources;
}