#pragma once

#include "String.h"

#include "File.h"
#include "Result.h"
#include <unistd.h>

class Process
{
public:
    Status launch(const String& command)
    {
        const auto pid = fork();
        if (pid < 0)
        {
            ON_ERRNO("Failed to fork");
        }

        if (pid == 0)
        {
            //pass
        }
        return {};
    }

    static Result<String> get_self_name()
    {
        FileSystemPath path(String("/proc/self/cmdline"));
        File sys_file(path);

        Result<String> ret;
        const auto rc = sys_file.readText(ret.value());
        if (!rc.ok())
        {
            ret.on_error(rc.error());
        }
        return ret;
    }
};